/******************************************************************************
*
*  Date: Fri  10-06-1994
*
*        DICT.CH
*
*        Header file for data dictionary library
*
* Copyright (c) 1994, Zero-1 Software Ltd.
*/


#define DIC_EVENT_NUMBER        1
#define DIC_EVENT_ENTITY        2

#define DIC_BASENAME             'DICT'

#define DIC_MAINDBF             (DIC_BASENAME + 'MAIN.DBF')
#define DIC_MAINIDX             (DIC_BASENAME + 'MAIN')
#define DIC_MAINTAG             (DIC_BASENAME + 'MAIN')

#define DIC_DBFDBF              (DIC_BASENAME + 'DBF.DBF')
#define DIC_DBFIDX              (DIC_BASENAME + 'DBF')
#define DIC_DBFTAG              (DIC_BASENAME + 'DBF')

#define DIC_IDXDBF              (DIC_BASENAME + 'IDX.DBF')
#define DIC_IDXIDX              (DIC_BASENAME + 'IDX')
#define DIC_IDXTAG              (DIC_BASENAME + 'IDX')

#define DIC_CALLBACK_STARTINDEX        1
#define DIC_CALLBACK_INDEXING          2
#define DIC_CALLBACK_STOPINDEX         3
#define DIC_CALLBACK_FIELDMISSING      4
#define DIC_CALLBACK_FIELDDIFF         5
#define DIC_CALLBACK_STARTAPPEND       6
#define DIC_CALLBACK_APPENDING         7
#define DIC_CALLBACK_STOPAPPEND        8
#define DIC_CALLBACK_SYSTEMIDX         9
#define DIC_CALLBACK_UPDATING         10
#define DIC_CALLBACK_FINISHEDUPDATING 11
#define DIC_CALLBACK_ASKCREATEDBF     12

#define DIC_ERR_NOERROR                    0    // nothing to bother about
#define DIC_ERR_ENTITYNOTFOUND            -1    // cannot find the entity in DICTMAIN
#define DIC_ERR_NOENTITYITEMSFOUND        -2    // cannot find and field defs in DICTDBF
#define DIC_ERR_DBFCREATEERROR            -3    // unable to create dbf from field specs
#define DIC_ERR_CALLBACK_REFUSEUPDATE     -4    // users refused to allow update via callback
#define DIC_ERR_CALLBACK_REFUSECREATEDBF  -5    // user refused to allow creation of DBF
#define DIC_ERR_UPDATERROR                -6    // probably couldn't rename file
#define DIC_ERR_INDEXCREATEERROR          -7    // invalid key or some such stuff
#define DIC_ERR_CANTOPENDBF               -8    // cant open DBF
#define DIC_ERR_UNABLETOADDDIC            -9    // unable to add DBF to dictionary


#define D_NAME        1 //C     10
#define D_DESC        2 //C     30
#define D_DBF         3 //C    128
#define D_ALIAS       4 //C     10
#define D_RDD         5 //C     10
#define D_FIELDS      6 //N      1
#define D_FIELDSTART  7 //N      2
#define D_IDXS        8 //N      1
#define D_IDXSTART    9 //N      2
#define LEN_DIC       9

#define DIC_INDEXPAGESIZE  (10+30+128+10+10+1+2+1+2)

#define MAX_DBFS     30


#define F_FIELDNAME  1
#define F_FIELDTYPE  2
#define F_FIELDLEN   3
#define F_FIELDDEC   4
#define LEN_FIELDS   4

#define X_IDXNAME    1
#define X_IDXTAG     2
#define X_IDXKEY     3
#define X_IDXFOR     4
#define X_IDXDESC    5
#define X_IDXUNIQUE  6
#define LEN_IDX      6



#command DEFAULT <v1> TO <x1> [, <vN> TO <xN>] =>    ;
      <v1> := if( <v1> # NIL, <v1>, <x1> )              ;
   [; <vN> := if( <vN> # NIL, <vN>, <xN> ) ]

#translate COMPILE( <exp> )       => &( "{||" + <exp> + "}" )



